Public Class FrmPrinc

    Private mFileList As ClsFileList = Nothing

    Private mAnalyse As ClsAnalyse = Nothing

#Region "FormEvents"

    Private Sub FrmPrinc_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        ClsBaseThread.StopAllThreads()
    End Sub

    Private Sub FrmPrinc_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        CmdOptReload_Click(Nothing, Nothing)
        TRefresh.Enabled = True


        'e
    End Sub
#End Region

#Region "Dossiers"

    Private Sub CmdBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdBrowse.Click
        With DiagDir
            .Description = "Slectionnez le dossier  ajouter  la liste"
            If TxtSelDir.Text.Length > 0 Then
                .SelectedPath = TxtSelDir.Text
            End If

            If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                TxtSelDir.Text = .SelectedPath
            End If
        End With
    End Sub

    Private Sub CmdAddDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdAddDir.Click
        If TxtSelDir.Text.Length > 0 AndAlso IO.Directory.Exists(TxtSelDir.Text) Then
            If LstDir.Items.Contains(TxtSelDir.Text) = False Then
                LstDir.Items.Add(TxtSelDir.Text)
                ChangeSave(Nothing, Nothing)
            End If
        End If
    End Sub

    Private Sub CmdRmvDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdRmvDir.Click
        If LstDir.SelectedIndex <> -1 Then
            TxtSelDir.Text = CStr(LstDir.SelectedItem)
            LstDir.Items.RemoveAt(LstDir.SelectedIndex)
            ChangeSave(Nothing, Nothing)
        End If
    End Sub

    Private Sub CmdDelDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdDelDir.Click
        If LstDir.SelectedIndex <> -1 Then
            LstDir.Items.RemoveAt(LstDir.SelectedIndex)
            ChangeSave(Nothing, Nothing)
        End If
    End Sub
#End Region

#Region "Options"

    Private Sub ChangeSave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkTypeMD5.CheckedChanged, ChkTypeExt.CheckedChanged, ChkTypeSize.CheckedChanged, ChkTypeName.CheckedChanged, TxtExtInc.TextChanged, TxtExtExc.TextChanged, OptMd5AllFile.Click, OptMd5FixedSize.Click, OptMd5PercentFile.Click, UDMd5FixedSize.ValueChanged, UDMd5PercentFile.ValueChanged

        Dim lGoodSave As Boolean = True
        Dim lGoodDir As Boolean = True

        'Choix de slection
        lGoodSave = lGoodSave And (ChkTypeMD5.Checked Or ChkTypeExt.Checked Or ChkTypeSize.Checked Or ChkTypeName.Checked)
        If (ChkTypeMD5.Checked Or ChkTypeExt.Checked Or ChkTypeSize.Checked Or ChkTypeName.Checked) = False Then
            GPTypeCtrl.BackColor = Color.Red
            TabTypeCtrl.BackColor = GPTypeCtrl.BackColor
        Else
            GPTypeCtrl.BackColor = System.Drawing.SystemColors.Control
            TabTypeCtrl.BackColor = GPTypeCtrl.BackColor
        End If
        'Extensions  inclure
        If TxtExtInc.Text.Length = 0 Then
            lGoodSave = False
            TxtExtInc.BackColor = Color.Red
        Else
            TxtExtInc.BackColor = System.Drawing.SystemColors.Window
        End If

        'Dossiers  parcourir
        If LstDir.Items.Count = 0 Then
            lGoodDir = False
            LstDir.BackColor = Color.Red
        Else
            LstDir.BackColor = System.Drawing.SystemColors.Window
        End If

        CmdOptSave.Enabled = lGoodSave
        CmdSearch.Enabled = lGoodSave And lGoodDir
    End Sub

    Private Sub CmdOptReload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdOptReload.Click

        Dim lCtrl As EFileCtrl = CType(My.Settings.TypeCtrl, EFileCtrl)
        ChkTypeExt.Checked = ((lCtrl And EFileCtrl.Extension) <> 0)
        ChkTypeMD5.Checked = ((lCtrl And EFileCtrl.MD5) <> 0)
        ChkTypeName.Checked = ((lCtrl And EFileCtrl.FileName) <> 0)
        ChkTypeSize.Checked = ((lCtrl And EFileCtrl.Taille) <> 0)

        OptMd5AllFile.Checked = False
        OptMd5FixedSize.Checked = False
        OptMd5PercentFile.Checked = False
        If My.Settings.CtrlMd5Size = "*" Then
            OptMd5AllFile.Checked = True
        ElseIf My.Settings.CtrlMd5Size.Substring(0, 1) = "k" Then
            If Not Decimal.TryParse(My.Settings.CtrlMd5Size.Substring(1), UDMd5FixedSize.Value) Then
                OptMd5AllFile.Checked = True
            Else
                OptMd5FixedSize.Checked = True
            End If
        ElseIf My.Settings.CtrlMd5Size.Substring(0, 1) = "%" Then
            If Not Decimal.TryParse(My.Settings.CtrlMd5Size.Substring(1), UDMd5PercentFile.Value) Then
                OptMd5AllFile.Checked = True
            Else
                OptMd5PercentFile.Checked = True
            End If
        End If


        TxtExtExc.Text = My.Settings.ExtExc
        TxtExtInc.Text = My.Settings.ExtInc
        CmdOptSave.Enabled = False
    End Sub

    Private Sub CmdOptSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdOptSave.Click

        Dim lCtrl As EFileCtrl = 0
        If ChkTypeExt.Checked Then
            lCtrl = lCtrl Or EFileCtrl.Extension
        End If
        If ChkTypeMD5.Checked Then
            lCtrl = lCtrl Or EFileCtrl.MD5
        End If
        If ChkTypeName.Checked Then
            lCtrl = lCtrl Or EFileCtrl.FileName
        End If
        If ChkTypeSize.Checked Then
            lCtrl = lCtrl Or EFileCtrl.Taille
        End If
        My.Settings.TypeCtrl = lCtrl

        My.Settings.ExtExc = TxtExtExc.Text
        My.Settings.ExtInc = TxtExtInc.Text

        If OptMd5AllFile.Checked Then
            My.Settings.CtrlMd5Size = "*"
        ElseIf OptMd5FixedSize.Checked Then
            My.Settings.CtrlMd5Size = String.Format("k{0}", UDMd5FixedSize.Value)
        ElseIf OptMd5PercentFile.Checked Then
            My.Settings.CtrlMd5Size = String.Format("%{0}", UDMd5PercentFile.Value)
        End If

        My.Settings.Save()

        CmdOptSave.Enabled = False
    End Sub

    Private Sub ChkTypeMD5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkTypeMD5.CheckedChanged
        GPMd5Size.Visible = ChkTypeMD5.Checked
    End Sub




#End Region

#Region "Actions"

    Private Sub CmdAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdAbout.Click
        My.Forms.FrmAbout.ShowDialog(Me)
    End Sub

    Private Sub CmdSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdSearch.Click
        If mFileList IsNot Nothing Or (mAnalyse IsNot Nothing AndAlso mAnalyse.IsRun) Then
            If mFileList IsNot Nothing Then
                mFileList.StopThread()
                mFileList = Nothing
            End If

            If mAnalyse IsNot Nothing Then
                mAnalyse.StopThread()
            End If
            Exit Sub
        End If

        Dim ltStr As New List(Of String)

        For Each lStr As String In LstDir.Items
            ltStr.Add(lStr)
        Next

        mFileList = New ClsFileList(ltStr)
        mAnalyse = New ClsAnalyse(mFileList)

        TVDbl.Nodes.Clear()
    End Sub
#End Region

#Region "Divers"

    Private Sub TRefresh_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TRefresh.Tick
        If mFileList Is Nothing Then
            LblDirName.Text = ""
            LblDirProgress.Text = CStr(LblDirProgress.Tag)
            LblFileName.Text = ""
            LblFileProgress.Text = CStr(LblFileProgress.Tag)
            PBDir.Minimum = 0
            PBDir.Maximum = 10
            PBDir.Value = 5
            PBFile.Minimum = 0
            PBFile.Maximum = 10
            PBFile.Value = 5
            Anim.Etat = CtlAnim.EEtat.Aucun
        Else
            With mFileList
                LblDirName.Text = .ActDir
                LblDirProgress.Text = CStr(LblDirProgress.Tag).Replace("%1", CStr(.NbAnalizedDir)).Replace("%2", CStr(.NbTotalDir)).Replace("%3", GetHMS(.TimeAnalizedDir)).Replace("%4", GetHMS(.TimeRemainingDir)).Replace("%5", GetHMS(.TimeTotalDir))
                LblFileName.Text = mFileList.ActFile
                LblFileProgress.Text = CStr(LblFileProgress.Tag).Replace("%1", CStr(.NbAnalizedFile)).Replace("%2", CStr(.NbTotalFile)).Replace("%3", GetHMS(.TimeAnalizedFile)).Replace("%4", GetHMS(.TimeRemainingFile)).Replace("%5", GetHMS(.TimeTotalFile))
                PBDir.Minimum = 0
                PBDir.Maximum = .NbTotalDir
                PBDir.Value = .NbAnalizedDir
                PBFile.Minimum = 0
                PBFile.Maximum = .NbTotalFile
                PBFile.Value = .NbAnalizedFile
            End With
            If mFileList.IsRun Then
                Anim.Etat = CtlAnim.EEtat.Scan
            ElseIf mFileList.ActFile.Length > 0 Then
                Anim.Etat = CtlAnim.EEtat.Wait
            Else
                Anim.Etat = CtlAnim.EEtat.Aucun
                mFileList = Nothing
            End If
        End If

        If mAnalyse Is Nothing Then
            LblNbDbl.Text = "Aucun rsultat  afficher"
        Else
            Try
                LblNbDbl.Text = CStr(LblNbDbl.Tag).Replace("%1", CStr(mAnalyse.NbDoublons))
                If mAnalyse.IsRun = False And TVDbl.Nodes.Count = 0 Then
                    TVDbl.Nodes.Clear()
                    TVDbl.Nodes.AddRange(mAnalyse.GetNodes.ToArray)
                    TVDbl.ExpandAll()
                End If
            Catch ex As Exception
            End Try
        End If

        If (mFileList IsNot Nothing AndAlso (mFileList.IsRun OrElse mFileList.NbRemainingFile > 0)) OrElse (mAnalyse IsNot Nothing AndAlso mAnalyse.IsRun) Then
            CmdSearch.Text = "&Arrter"
        Else
            CmdSearch.Text = "&Rechercher"
        End If
    End Sub

    Private Function GetHMS(ByVal pTimer As Double) As String
        Dim lStr As String = Format((CInt(pTimer) Mod 60), "00")
        pTimer -= pTimer Mod 60
        pTimer /= 60
        lStr = Format(pTimer Mod 60, "00") + ":" + lStr
        pTimer -= pTimer Mod 60
        pTimer /= 60
        lStr = Format(pTimer Mod 60, "00") + ":" + lStr
        Return lStr
    End Function
#End Region

#Region "Liste des doublons"

    Private Sub TVDbl_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TVDbl.AfterSelect
        Try
            Dim lName As String = CStr(e.Node.Tag)
            TxtPropAttrib.Text = GetTxtAttrib(IO.File.GetAttributes(lName))
            TxtPropDateCreate.Text = IO.File.GetCreationTime(lName).ToString
            TxtPropDateModif.Text = IO.File.GetLastWriteTime(lName).ToString
            TxtPropDir.Text = IO.Path.GetDirectoryName(lName)
            TxtPropFileName.Text = IO.Path.GetFileName(lName)
            TxtPropSize.Text = GetTxtSize(My.Computer.FileSystem.GetFileInfo(lName).Length)
        Catch ex As Exception
            TxtPropAttrib.Text = ""
            TxtPropDateCreate.Text = ""
            TxtPropDateModif.Text = ""
            TxtPropDir.Text = ""
            TxtPropFileName.Text = ""
            TxtPropSize.Text = ""
        End Try
    End Sub

    Private Function GetTxtSize(ByVal pLen As Long) As String
        If pLen = 0 Then Return "0 o"

        Dim i As Integer = CInt(Math.Floor((Math.Log(pLen) / Math.Log(2)) / 10))
        Dim lStr As String = Format(pLen / (2 ^ (i * 10)), "0.##")

        Select Case i
            Case 0
                lStr += " o"
            Case 1
                lStr += " ko"
            Case 2
                lStr += " Mo"
            Case 3
                lStr += " Go"
            Case 4
                lStr += " To"
            Case 5
                lStr += " Po"
            Case Else
                lStr += " *2^" + CStr(i)
        End Select

        Return lStr
    End Function

    Private Function GetTxtAttrib(ByVal pAttr As IO.FileAttributes) As String
        Dim lStr As String = ""

        If (pAttr And IO.FileAttributes.Archive) <> 0 Then
            lStr += "Arc "
        End If

        If (pAttr And IO.FileAttributes.Compressed) <> 0 Then
            lStr += "Cmp "
        End If

        If (pAttr And IO.FileAttributes.Encrypted) <> 0 Then
            lStr += "Enc "
        End If

        If (pAttr And IO.FileAttributes.Hidden) <> 0 Then
            lStr += "Hid "
        End If

        If (pAttr And IO.FileAttributes.ReadOnly) <> 0 Then
            lStr += "RO "
        End If

        If (pAttr And IO.FileAttributes.NotContentIndexed) = 0 Then
            lStr += "Ind "
        End If

        Return lStr.Trim
    End Function

    Private Sub CmdSelAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdSelAll.Click
        For Each lNode1 As TreeNode In TVDbl.Nodes
            For Each lNode2 As TreeNode In lNode1.Nodes
                lNode2.Checked = True
            Next
            lNode1.Checked = False
        Next
    End Sub

    Private Sub CmdSelNone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdSelNone.Click
        For Each lNode1 As TreeNode In TVDbl.Nodes
            For Each lNode2 As TreeNode In lNode1.Nodes
                lNode2.Checked = False
            Next
            lNode1.Checked = False
        Next
    End Sub

    Private Sub CmdSelInvert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdSelInvert.Click
        For Each lNode1 As TreeNode In TVDbl.Nodes
            For Each lNode2 As TreeNode In lNode1.Nodes
                lNode2.Checked = Not (lNode2.Checked)
            Next
            lNode1.Checked = Not (lNode1.Checked)
        Next
    End Sub

    Private Sub CmdActDel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdActDel.Click
        Dim lList As New List(Of String)

        For Each lNode1 As TreeNode In TVDbl.Nodes
            For Each lNode2 As TreeNode In lNode1.Nodes
                If lNode2.Checked AndAlso IO.File.Exists(CStr(lNode2.Tag)) Then
                    lList.Add(CStr(lNode2.Tag))
                End If
            Next

            If lNode1.Checked AndAlso IO.File.Exists(CStr(lNode1.Tag)) Then
                lList.Add(CStr(lNode1.Tag))
            End If
        Next

        If lList.Count = 0 Then Exit Sub

        If My.Forms.FrmLstFile.ShowDialog(Me, lList) = Windows.Forms.DialogResult.Cancel Then Exit Sub

        If lList.Count = 0 Then Exit Sub

        System.GC.Collect()
        GC.WaitForPendingFinalizers()

        With My.Forms.FrmAction

            .Text = "Suppression"
            .Show(Me)
            .PB.Value = 0
            .PB.Maximum = lList.Count

            For i As Integer = 0 To 99
                If lList.Count = 0 Then Exit For
                For Each lStr As String In lList
                    Try
                        IO.File.Delete(lStr)
                    Catch ex As Exception
                    End Try
                Next
                For j As Integer = 0 To lList.Count - 1
                    If j >= 0 And j < lList.Count Then
                        If IO.File.Exists(lList(j)) = False Then
                            lList.RemoveAt(j)
                            j -= 2
                        End If
                    End If
                Next
                .PB.Value = .PB.Maximum - lList.Count
                System.GC.Collect()
                GC.WaitForPendingFinalizers()
                Application.DoEvents()
            Next

            .Close()
        End With

        If lList.Count > 0 Then
            If MessageBox.Show(CStr(lList.Count) + " fichier(s) n'ont pas t supprims, voulez-vous rssayer ?", "Suppression", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                CmdActDel_Click(sender, e)
            End If
        End If
    End Sub

    Private Sub CmdActMove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdActMove.Click
        MessageBox.Show("Non code, veuillez contacter l'auteur (nhprog@laposte.net Fr/En) pour une mise  jour")
        Exit Sub
    End Sub

    Private Sub CmdActFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdActFile.Click
        MessageBox.Show("Non code, veuillez contacter l'auteur (nhprog@laposte.net Fr/En) pour une mise  jour")
        Exit Sub
    End Sub
#End Region

    Private Sub OptMd5Size_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OptMd5AllFile.CheckedChanged, OptMd5PercentFile.CheckedChanged, OptMd5FixedSize.CheckedChanged
        If sender Is OptMd5AllFile Then
            If DirectCast(sender, RadioButton).Checked Then
                OptMd5PercentFile.Checked = False
                OptMd5FixedSize.Checked = False
            End If
        ElseIf sender Is OptMd5PercentFile Then
            If DirectCast(sender, RadioButton).Checked Then
                OptMd5AllFile.Checked = False
                OptMd5FixedSize.Checked = False
            End If
            PanOptMd5PercentFile.Visible = OptMd5PercentFile.Checked
        ElseIf sender Is OptMd5FixedSize Then
            If DirectCast(sender, RadioButton).Checked Then
                OptMd5AllFile.Checked = False
                OptMd5PercentFile.Checked = False
            End If
            PanMd5FixedSize.Visible = OptMd5FixedSize.Checked
        End If
    End Sub
End Class
